package fr.lri.keller.td2;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;

public class TD2Activity extends AppCompatActivity {

    private EditText addLHS, addRHS, value;
    private TextView result, resultAdd, resultSub, resultMul, resultDiv;

    // Choisir la méthode onCreate selon l'interface voulue

    @Override
    // Interface de base
//    protected void onCreate(Bundle savedInstanceState) {
//        super.onCreate(savedInstanceState);
//        setContentView(R.layout.activity_td2);
//        addLHS = (EditText) findViewById(R.id.addLHS);
//        addRHS = (EditText) findViewById(R.id.addRHS);
//        result = (TextView) findViewById(R.id.result);
//    }

    // Interface pour les quatre opérations
//    protected void onCreate(Bundle savedInstanceState) {
//        super.onCreate(savedInstanceState);
//        setContentView(R.layout.activity_td2_4op);
//        addLHS = (EditText) findViewById(R.id.addLHS);
//        addRHS = (EditText) findViewById(R.id.addRHS);
//        resultAdd = (TextView) findViewById(R.id.resultAdd);
//        resultSub = (TextView) findViewById(R.id.resultSub);
//        resultMul = (TextView) findViewById(R.id.resultMul);
//        resultDiv = (TextView) findViewById(R.id.resultDiv);
//    }

    // Interface pour la calculatrice enchaînant les additions
//    protected void onCreate(Bundle savedInstanceState) {
//        super.onCreate(savedInstanceState);
//        setContentView(R.layout.activity_td2_addcalc);
//        value = (EditText) findViewById(R.id.value);
//    }

    // Interface pour la calculatrice basique
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_td2_calc);
        result = (TextView) findViewById(R.id.result);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_td2, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }


    // Action du bouton dans la configuration de base
    public void computeAdd(View v) {
        int lhs = 0;
        int rhs = 0;
        try {
            lhs = Integer.parseInt(addLHS.getText().toString());
        } catch (NumberFormatException e) {
        }
        try {
            rhs = Integer.parseInt(addRHS.getText().toString());
        } catch (NumberFormatException e) {
        }
        int r = lhs + rhs;
        result.setText(r + "");
    }


    // Action du bouton avec les quatre opérations
    public void compute4op(View v) {
        int lhs = 0;
        int rhs = 0;
        try {
            lhs = Integer.parseInt(addLHS.getText().toString());
        } catch (NumberFormatException e) {
        }
        try {
            rhs = Integer.parseInt(addRHS.getText().toString());
        } catch (NumberFormatException e) {
        }
        int rAdd = lhs + rhs;
        int rSub = lhs - rhs;
        int rMul = lhs * rhs;
        int rDiv = 0;
        try {
            rDiv = lhs / rhs;
        } catch (ArithmeticException e) {
        }
        resultAdd.setText(rAdd + "");
        resultSub.setText(rSub + "");
        resultMul.setText(rMul + "");
        resultDiv.setText(rDiv + "");
    }


    // Action des divers boutons de la calculatrice enchaînant les additions
    private int res = 0;

    public void computeAddcalcAdd(View v) {
        int x = 0;
        try {
            x = Integer.parseInt(value.getText().toString());
        } catch (NumberFormatException e) {
        }
        res += x;
    }

    public void computeAddcalcEqual(View v) {
        computeAddcalcAdd(v);
        value.setText(res + "");
        res = 0;
    }

    public void computeAddcalcInit(View v) {
        value.setText("");
        res = 0;
    }


    // Action des divers boutons de la calculatrice basique
    private int number = 0;
    private int res2 = 0;
    private boolean lastEqual = true;
    private boolean sub = false;
    private boolean minus = false;
    private Integer mult = null;

    // Méthode générique pour afficher les nombres
    private void printNumber() {
        if (minus) {
            result.setText("-" + number);
        } else {
            result.setText("" + number);
        }
    }

    // Méthode appelée lorsque l'utilisateur appuie sur un chiffre
    private void pressDigit(int d) {
        if (lastEqual) {
            lastEqual = false;
            res2 = 0;
        }
        number = 10 * number + d;
        printNumber();
    }

    public void press0(View v) {
        pressDigit(0);
    }

    public void press1(View v) {
        pressDigit(1);
    }

    public void press2(View v) {
        pressDigit(2);
    }

    public void press3(View v) {
        pressDigit(3);
    }

    public void press4(View v) {
        pressDigit(4);
    }

    public void press5(View v) {
        pressDigit(5);
    }

    public void press6(View v) {
        pressDigit(6);
    }

    public void press7(View v) {
        pressDigit(7);
    }

    public void press8(View v) {
        pressDigit(8);
    }

    public void press9(View v) {
        pressDigit(9);
    }

    // L'idée générale de l'algo est de se souvenir des additions effectuées jusque là, ainsi que
    // de la multiplication courante, s'il y en a une. Lorsque l'utilisateur choisit une opération,
    // on va traiter l'opération précédente, puis changer de mode en fonction de cette nouvelle
    // opération.

    // Méthode appelée lorsque l'utilisateur appuie sur "+"
    public void computeCalcAdd(View v) {
        if (sub ^ minus) {
            number = -number;
        }
        if (mult == null) {
            res2 += number;
        } else {
            res2 += mult * number;
            mult = null;
        }
        number = 0;
        lastEqual = false;
        sub = false;
        minus = false;
    }

    // Méthode appelée lorsque l'utilisateur appuie sur "-"
    public void computeCalcSub(View v) {
        if (sub ^ minus) {
            number = -number;
        }
        if (mult == null) {
            res2 += number;
        } else {
            res2 += mult * number;
            mult = null;
        }
        number = 0;
        lastEqual = false;
        sub = true;
        minus = false;
    }

    // Méthode appelée lorsque l'utilisateur appuie sur "*"
    public void computeCalcMul(View v) {
        if (sub ^ minus) {
            number = -number;
        }
        if (mult == null) {
            mult = number;
        } else {
            mult *= number;
        }
        number = 0;
        lastEqual = false;
        sub = false;
        minus = false;
    }

    public void computeCalcInit(View v) {
        number = 0;
        res2 = 0;
        lastEqual = true;
        sub = false;
        minus = false;
        mult = null;
        result.setText("0");
    }

    public void computeCalcMinus(View v) {
        minus = true;
        result.setText("-");
    }

    public void computeCalcEqual(View v) {
        computeCalcAdd(v);
        lastEqual = true;
        sub = false;
        minus = false;
        result.setText(res2 + "");
    }

}